% Script donnant le portrait de phase d'une trajectoires d'un pendule
% simple, d'aprs les conditions initiales rentres numriquement ou graphiquement.
clear
% Entre des CI
answer = inputdlg({'L ? ','m ?','g ?','t(max) ?','delta_t ?','Vitesse d''affichage'},...
    'Entrez les Conditions Initiales',1,{'0.5','0.1','10','10','0.01','9'});
L=str2num(answer{1});
m=str2num(answer{2});
ga=str2num(answer{3});
tm=str2num(answer{4});
delta_t=str2num(answer{5});
sp=str2num(answer{6});
t=0:delta_t:tm;
rep=input('CI (phi et phi'') entres numriquement (n) ou graphiquement (g) ?','s');
if rep=='n'
    y=ps_port_ph_num(L,m,ga,tm,delta_t); % Appel de la fonction demandant les CI tapes
elseif rep=='g'
    figure('name',['Trame du portrait de phase'],'Color',[1 1 1]) % Figure cre, et bloque
    hold on
    H=[ga/L,2*ga/L,3*ga/L,4*ga/L,5*ga/L,6*ga/L,7*ga/L,8*ga/L,12*ga/L]; % Diffrentes valeurs de l'hamiltonien du systme
    theta=[-2*pi:0.01:2*pi]; % Vecteur angle pour le graph du portrait de phase
    for i=1:length(H)
    dthetap(i,:)=+(H(i)-2*ga/L.*(1-cos(theta))).^0.5;
    dthetam(i,:)=-(H(i)-2*ga/L.*(1-cos(theta))).^0.5;
    plot(theta,real(dthetap),'k:',theta,real(dthetam),'k:'),xlim([-2*pi 2*pi]),ylim([-max(dthetap(length(H))) +max(dthetap(length(H)))]),xlabel('phi'),ylabel('phi''')
    end
    [phi1,phi1p]=ginput(1); % Entre par le graphique des CI
    y=ps_port_ph_graph(L,m,ga,tm,delta_t,phi1,phi1p); % Appel de la fonction demandant utilisant les CI cliques
end
close all

% Trac de la trame du portrait de phase
H=[ga/L,2*ga/L,3*ga/L,4*ga/L,5*ga/L,6*ga/L,7*ga/L,8*ga/L,12*ga/L];
theta=[-2*pi:0.01:2*pi];
figure('name',['Portrait de phase'],'Color',[1 1 1])
hold on
for i=1:length(H)
    dthetap(i,:)=+(H(i)-2*ga/L.*(1-cos(theta))).^0.5;
    dthetam(i,:)=-(H(i)-2*ga/L.*(1-cos(theta))).^0.5;
    plot(theta,real(dthetap),'k:',theta,real(dthetam),'k:')
end
% Trac dynamique de la trajectoire.
for j=1:length(t)-1
if mod(j,sp)==0
    plot(y(1,1:j),y(2,1:j)),xlim([-2*pi 2*pi]),ylim([-max(dthetap(length(H))) +max(dthetap(length(H)))]),xlabel('phi'),ylabel('phi''')
drawnow
end
end